#! /bin/sh
#####################################################
#     本脚本仅供ubiquity调用，目的在系统            #
#     安装时，针对本机安装专有硬件驱动程            #
#     序,且该专有驱动包仅存在于ISO，绝大            #
#     部分将不放入目标系统。                        #
#                                                   #
#     特别注意：                                    #
#     该脚本将根据硬件升级而不断升级，并            #
#     且要兼容早期平台。因此，修改此脚本            #
#     需保留早期平台判定，若无必要，不可            #
#     去掉早期平台功能。谨眞修改!!!                 #
#                                                   #
#     2016-11-09, by NFS xunian Tang                #
#     This shell just for ubiquity to               #
#     install some drivers when install             #
#     system...                                     #
#     2017-09-13,整体结构调整。
#####################################################
#安装驱动包，需结合系统安装环境进行.例子:
# chroot /target /bin/bash -c "dpkg -i /usr/local/nfsdrivers/"$s3g_edition"*.deb"

#ISO中驱动软件包的目录
DRV_PATH="/usr/local/nfsdrivers"

#获取primary显卡信息
################# 根据boot_vga的值来确定哪块显卡是primary #############
hwif="/tmp/hwif.txt"
hwinf1="/tmp/hwinfo1.txt"
hwinf2="/tmp/hwinfo2.txt"

GCARD1_VENDOR=""
GCARD1_PATH=""
GCARD2_VENDOR=""
GCARD2_PATH=""
PGCARD_VENDORID=""

vga_via=""
vga_zhaoxin=""
vga_ati=""
vga_nvidia=""

rm -rf $hwif $hwinf1 $hwinf2
hwinfo --gfxcard > $hwif
CARDNUMBER=`cat $hwif | grep "SysFS ID:" | wc -l`

if [ $CARDNUMBER -eq 1 -o $CARDNUMBER -eq 2 ]; then
	#处理设备信息
	grep -E " SysFS ID: | Vendor: " $hwif > $hwinf1
	sed -i 's/^[ \t]*//g' $hwinf1 #去掉行首空格

	cat $hwinf1 | awk -F " " '{print $3}' > $hwinf2
#	while read -r line
#	do
#		echo $line | awk -F " " '{print $3}' >> $hwinf2
#	done < $hwinf1
else
	echo "Error"
	exit 0
fi

FILENUMBER=`cat $hwinf2 | wc -l` #获取文件行数
if [ $CARDNUMBER -eq 1 -a $FILENUMBER -eq 2 ]; then
	GCARD1_PATH=`sed -n '1p' $hwinf2`
	GCARD1_VENDOR=`sed -n '2p' $hwinf2`

	#GCARD1_FILEPATH=`echo "/sys"${GCARD1_PATH}"/boot_vga"`
	#GCARD1_BOOT=`cat $GCARD1_FILEPATH`
	#if [ $GCARD1_BOOT -eq 1 ]; then
		PGCARD_VENDORID=$GCARD1_VENDOR
	#fi
fi
if [ $CARDNUMBER -eq 2 -a $FILENUMBER -eq 4 ]; then
	GCARD1_PATH=`sed -n '1p' $hwinf2`
	GCARD1_VENDOR=`sed -n '2p' $hwinf2`

	GCARD2_PATH=`sed -n '3p' $hwinf2`
	GCARD2_VENDOR=`sed -n '4p' $hwinf2`

	GCARD1_FILEPATH=`echo "/sys"${GCARD1_PATH}"/boot_vga"`
	GCARD1_BOOT=`cat $GCARD1_FILEPATH`
	GCARD2_FILEPATH=`echo "/sys"${GCARD2_PATH}"/boot_vga"`
	GCARD2_BOOT=`cat $GCARD2_FILEPATH`

	if [ $GCARD1_BOOT -eq 1 ]; then
		PGCARD_VENDORID=$GCARD1_VENDOR
	fi
	if [ $GCARD2_BOOT -eq 1 ]; then
		PGCARD_VENDORID=$GCARD2_VENDOR
	fi
fi

case $PGCARD_VENDORID in
	0x1106*)
	#ZXC集显支持
	vga_via=$PGCARD_VENDORID
	;;
	0x1d17*)
	#ZXD集显支持
	vga_zhaoxin=$PGCARD_VENDORID
	;;
	0x1002*)
	#A卡支持
	vga_ati=$PGCARD_VENDORID
	;;
	0x10de*)
	#N卡支持
	vga_nvidia=$PGCARD_VENDORID
	;;
	*)
	echo "Other VendorID: $PGCARD_VENDORID, Not supported!"
	exit 0
	;;
esac

############ end 根据boot_vga的值来确定哪块显卡是primary #################


########## OS1.5+ZXC, 安装各机型驱动 ##########

#OS1.5+ZXC_CF03, INSTALL DIRVERS.
install_15_zxc_cf03_drv()
{
	#安装集成显卡驱动
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/s3-linux-graphics-driver_*.deb"

	#安装键盘映射包
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/hotkey-init_*.deb"

	#安装标配的外置usb wifi驱动。内核版本，3.xx,安装usb-wifi驱动， 4.xxx，版本不安装
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/tl-wn725n_*.deb"
}

#OS1.5+ZXC_CF03T, INSTALL DIRVERS.
install_15_zxc_cf03t_drv()
{
	#安装集成显卡驱动
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/s3-linux-graphics-driver_*.deb"

	#安装键盘映射包
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/hotkey-init_*.deb"

	#安装内置wifi驱动包
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/backports-4.4.2-1_*.deb"

	#安装cf03-t patch，目的针对该平台的系统，首次开机动态調整系统部分配置文件，如网络唤醒开关开启或关闭
	#chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/cf03t-patch_*.deb" #该包出过测试版，正式版移除
}

#OS1.5+ZXC/ZXC+/ZXA, INSTALL DIRVERS.
install_15_ZXC_drv()
{
	#安装显卡驱动，根据所用显卡类型，安装对应的显卡驱动
	if [ "${vga_via}" != "" ]; then
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/s3-linux-graphics-driver_*.deb"
	elif [ "${vga_nvidia}" != "" ]; then
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/nvidia*.deb"
	elif [ "${vga_ati}" != "" ]; then
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/fglrx*.deb"
	else
        	echo "New graphics?"
	fi

	#安装CF03外置usb wifi驱动。内核版本，3.xx,安装usb-wifi驱动， 4.xxx，版本不安装
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/tl-wn725n_*.deb"
}

#OS1.5+ZXC_AIO, INSTALL DIRVERS.
install_15_zxc_AIO_drv()
{
	#安装A310独显驱动
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/fglrx*.deb"

	#安装wifi&&bt驱动
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/backports-20150903_*.deb"
}

#OS1.5+ZXC_INESA(miniPC), INSTALL DIRVERS.
install_15_zxc_INESA_drv()
{
	#安装集成显卡驱动
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/s3-linux-graphics-driver-2d3d-only_*.deb"
}

########## OS2.0+ZXC, 安装各机型驱动 ##########

#OS2.0+ZXC_CF03, INSTALL DIRVERS.
install_20_zxc_cf03_drv()
{
	#安装集成显卡驱动
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/s3-linux-graphics-driver_*.deb"

	#安装键盘映射包,需确认是否要安装
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/hotkey-init_*.deb"

	#标配的外置usb wifi驱动，目前不支持4.x版本内核。
}

#OS2.0+ZXC_CF03T, INSTALL DIRVERS.
install_20_zxc_cf03t_drv()
{
	#安装集成显卡驱动
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/s3-linux-graphics-driver_*.deb"

	#安装键盘映射包.需确认是否需要
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/hotkey-init_*.deb"

	#安装内置wifi驱动包
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/backports-4.4.2-1_*.deb"
}

#OS2.0+ZXC/ZXC+/ZXA, INSTALL DIRVERS.
install_20_ZXC_drv()
{
	#安装显卡驱动，根据所用显卡类型，安装对应的显卡驱动
	if [ "${vga_via}" != "" ]; then
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/s3-linux-graphics-driver_*.deb"
	elif [ "${vga_nvidia}" != "" ]; then
        	echo "Found nvidia graphics, but no driver to install"
	elif [ "${vga_ati}" != "" ]; then
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/fglrx*.deb"
	else
        	echo "New graphics?"
	fi

	#CF03外置的usb wifi驱动，目前不支持4.x版本内核。
}

#OS2.0+ZXC_AIO, INSTALL DIRVERS.
install_20_zxc_AIO_drv()
{
	#安装A310独显驱动
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/fglrx*.deb"

	#安装wifi&&bt驱动,需确认验证是否有效
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/backports-20150903_*.deb"
}

#OS2.0+ZXC_INESA(miniPC), INSTALL DIRVERS.
install_20_zxc_INESA_drv()
{
	#显卡驱动安装，目前与OS1.5同
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/s3-linux-graphics-driver-2d3d-only_*.deb"
}

########## OS3.0+ZXC, 安装各机型驱动 ##########

##### 发行版3.0 ISO 默认集成ZXC s3g驱动时，需处理 #########
#若默认不集成，执行该命令无碍。
purge_30_s3g_drivers()
{
	#zxc
	chroot /target /bin/bash -c "dpkg -P xserver-xorg-video-s3g"
	#zxd
	###2018-0409 去除'-30'，为兼容"-30"而修改，在无影响情况下，保留早期代码
	chroot /target /bin/bash -c "dpkg -P zhaoxin-chx001-linux-graphics-driver-30"
	chroot /target /bin/bash -c "dpkg -P zhaoxin-chx001-linux-graphics-driver"
}

#OS3.0+ZXC_CF03, INSTALL DIRVERS.
install_30_zxc_cf03_drv()
{
	#安装集成显卡驱动
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/xserver-xorg-video-s3g_*.deb"

	#安装键盘映射包,需确认是否要安装
	#chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/hotkey-init_*.deb"

	#标配的外置usb wifi驱动，目前不支持4.x版本内核。
}

#OS3.0+ZXC_CF03T, INSTALL DIRVERS.
install_30_zxc_cf03t_drv()
{
	#安装集成显卡驱动
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/xserver-xorg-video-s3g_*.deb"

	#安装键盘映射包.需确认是否需要
	#chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/hotkey-init_*.deb"

	#安装内置wifi驱动包
	#chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/backports-4.4.2-1_*.deb"
}

#OS3.0+ZXC/ZXC+/ZXA, INSTALL DIRVERS.
install_30_ZXC_drv()
{
	#安装显卡驱动，根据所用显卡类型，安装对应的显卡驱动
	if [ "${vga_via}" != "" ]; then
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/xserver-xorg-video-s3g_*.deb"
	elif [ "${vga_nvidia}" != "" ]; then
		echo "Found nvidia graphics, but no driver to install"
	elif [ "${vga_ati}" != "" ]; then
		echo "Found amd/ati graphics, but no driver to install"
	else
        	echo "New graphics?"
	fi

	#CF03外置的usb wifi驱动，目前不支持4.x版本内核。
}

#OS3.0+ZXC_AIO, INSTALL DIRVERS.
install_30_zxc_AIO_drv()
{
	#安装显卡驱动
	echo "Found A310 graphics, but no driver to install"

	#安装wifi&&bt驱动,需确认验证是否有效
	#chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/backports-20150903_*.deb"
}

#OS3.0+ZXC_INESA(miniPC), INSTALL DIRVERS.
install_30_zxc_INESA_drv()
{
	#安装集成显卡驱动
	chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/xserver-xorg-video-s3g_*.deb"
}

########## OS1.5+ZXD, 安装各机型驱动 ##########

#OS1.5+ZXD, install drivers.
install_15_ZXD_drv()
{
	#安装显卡驱动
	#echo "install zxd+1.5 graphics driver"
	#安装显卡驱动，根据所用显卡类型，安装对应的显卡驱动
	if [ "${vga_zhaoxin}" != "" ]; then
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/zhaoxin-chx001-linux-graphics-driver_*.deb"
	elif [ "${vga_nvidia}" != "" ]; then
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/nvidia*.deb"
	elif [ "${vga_ati}" != "" ]; then
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/fglrx*.deb"
	else
        	echo "New graphics?"
	fi
}

#OS1.5+ZXD,AIO install drivers.
install_15_zxd_AIO_drv()
{
	echo "install zxd+1.5 AIO drivers"
}

########## OS2.0+ZXD, 安装各机型驱动 ##########

#OS2.0+ZXD, install drivers.
install_20_ZXD_drv()
{
	#安装显卡驱动
	#echo "install zxd+2.0 graphics driver"
	if [ "${vga_zhaoxin}" != "" ]; then
		#echo "Found ZXD graphics, but no driver for OS2.0 to install"
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/zhaoxin-chx001-linux-graphics-driver_*.deb"
	elif [ "${vga_nvidia}" != "" ]; then
		echo "Found nvidia graphics, but no driver for OS2.0 to install"
	elif [ "${vga_ati}" != "" ]; then
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/fglrx*.deb"
	else
		echo "New graphics?"
	fi
}

install_20_zxd_AIO_drv()
{
	echo "install_20_zxd_AIO_drv"
}

########## OS3.0+ZXD, 安装各机型驱动 ##########

#OS3.0+ZXD, install drivers.
install_30_ZXD_drv()
{
	#安装显卡驱动
	#echo "install zxd+3.0 graphics driver"
	#安装显卡驱动，根据所用显卡类型，安装对应的显卡驱动
	if [ "${vga_zhaoxin}" != "" ]; then
		###2018-0409 去除'-30'，为兼容"-30"而修改
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/zhaoxin-chx001-linux-graphics-driver*.deb"
	elif [ "${vga_nvidia}" != "" ]; then
		echo "Found nvidia graphics,but no nvidia driver to install."
	elif [ "${vga_ati}" != "" ]; then
		echo "Found nvidia graphics,but no amd driver to install."
	else
		echo "New graphics?"
	fi
}

install_30_zxd_AIO_drv()
{
	echo "install zxd+3.0 AIO graphics driver"
}

########## OS1.5+ZXE, 安装驱动 ##########

##暂未处理

########## OS2.0+ZXE, 安装驱动 ##########

##暂未处理

########## OS3.0+ZXE, 安装驱动 ##########

#OS3.0+ZXE, install drivers.
install_30_ZXE_drv()
{
	#安装显卡驱动
	#echo "install zxe+3.0 graphics driver"
	#安装显卡驱动，根据所用显卡类型，安装对应的显卡驱动
	if [ "${vga_zhaoxin}" != "" ]; then #ZXE集显设备ID为1d17:3a04
		#201901,兆芯计划ZXE及后续平台，所有驱动合并为一个，驱动名称为：zhaoxin-linux-graphics-driver。
		#在ZXE平台，使用cpuinfo中的Model（bit[3:0]）字段和Extend Model（bit[5:4]）字段，作为平台判定条件。
		chroot /target /bin/bash -c "dpkg -i ${DRV_PATH}/zhaoxin-linux-graphics-driver*.deb"
	elif [ "${vga_nvidia}" != "" ]; then
		echo "Found nvidia graphics,but no nvidia driver to install."
	elif [ "${vga_ati}" != "" ]; then
		echo "Found nvidia graphics,but no amd driver to install."
	else
		echo "New graphics?"
	fi
}


############################# 识别平台类型 ####################################

#获取主板厂家信息，通过该信息判定硬件平台型号
#主板厂商识别
MANUFACTURER=`dmidecode -t baseboard | grep Manufacturer | awk '{print $2 }'`
#为获取含有空格的字段：Product Name: OptiPlex 360 ，需修改规则：awk -F ":";并采用去掉前后多余空格办法获取值
PROD_NAME=`dmidecode -t system | grep  -i "Product Name" | awk -F ":" '{print $2}' | sed 's/^[ \t]*//g' | sed 's/[ \t]*$//g'`
#统一将PROD_NAME值转换为大写
PRODUCT_NAME=`echo $PROD_NAME | tr '[a-z]' '[A-Z]'`
#获取Version信息，因AIO系统只能通过Version信息来进行平台判定,需区分大小写
VERSION_NAME=`dmidecode -t system | grep  -i "Version" | awk -F ":" '{print $2}' | sed 's/^[ \t]*//g' | sed 's/[ \t]*$//g'`

########## ZXC机型支持 ##########

#ZXC平台+1.5系统。ZXC平台支持台式机、AIO一体机、CF03笔记本、CF03-T笔记本和miniPC。
ZXC_15_install_drv()
{
#echo "ZXC_15_install_drv"

#ZXC:miniPC
if [ "$MANUFACTURER" = "INESA" ]; then
	#echo "install_15_zxc_INESA_drv"
	install_15_zxc_INESA_drv

#ZXC:台式机、AIO一体机、CF03笔记本、CF03-T笔记本; 含ZXC+和ZXA处理
elif [ "$MANUFACTURER" = "LENOVO" ]; then

	case ${PRODUCT_NAME} in
		#针对ZXC CF03笔记本
		CF03)
			#echo "install_15_zxc_cf03_drv"
			install_15_zxc_cf03_drv
		;;

		#针对笔记本ZXC CF03-T笔记本
		CF03-T)
			#echo "install_15_zxc_cf03t_drv"
			install_15_zxc_cf03t_drv
		;;
		#Add other platform here...

		#zxa\zxc\zxc+\aio台式开发机支持。
                #注意该项包含AIO开发机支持，但无法区分zxa\zxc\zxc+台式机和aio，使用的是zxc台式机的驱动，只能手动测试。
		FFFFFFFFFF)
			#echo "install_15_ZXC_drv"
			install_15_ZXC_drv
		;;
		#其他硬件平台,默认安装的驱动在此。
                #说明：工厂出货的zxc/zxc+/aio版本，无法通过PRODUCT_NAME识别（不同项目或批次的机器，其他PRODUCT_NAME不同），改用VERSION_NAME识别。
                #VERSION_NAME，AIO:KaiTianA6100, ZXC与ZXC+:KaiTianM6100
		*)
			case ${VERSION_NAME} in
				#工厂出货的AIO机型
				KaiTianA6100)
					#echo "install_15_zxc_AIO_drv"
					install_15_zxc_AIO_drv
				;;

				#工厂出货的zxc\zxc+机型
				KaiTianM6100 | KaiTianS6100)
					#echo "install_15_ZXC_drv"
					install_15_ZXC_drv
				;;

				*)
				;;
			esac
		;;
	esac
else
	echo "New machine?"
fi
}

#ZXC平台+2.0系统。ZXC平台支持台式机、AIO一体机、CF03笔记本、CF03-T笔记本和miniPC。
ZXC_20_install_drv()
{
#echo "ZXC_20_install_drv"

#ZXC:miniPC
if [ "$MANUFACTURER" = "INESA" ]; then
	#echo "install_20_zxc_INESA_drv"
	install_20_zxc_INESA_drv

#ZXC:台式机、AIO一体机、CF03笔记本、CF03-T笔记本; 含ZXC+和ZXA处理
elif [ "$MANUFACTURER" = "LENOVO" ]; then

	case ${PRODUCT_NAME} in
		#针对ZXC CF03笔记本
		CF03)
			#echo "install_20_zxc_cf03_drv"
			install_20_zxc_cf03_drv
		;;

		#针对笔记本ZXC CF03-T笔记本
		CF03-T)
			#echo "install_20_zxc_cf03t_drv"
			install_20_zxc_cf03t_drv
		;;
		#Add other platform here...

		#zxa\zxc\zxc+\aio\台式开发机支持。
		#注意该项包含AIO开发机支持，但无法区分zxa\zxc\zxc+台式机和aio，使用的是zxc台式机的驱动，只能手动测试。
		FFFFFFFFFF)
			#echo "install_20_ZXC_drv"
			install_20_ZXC_drv
		;;

		#其他硬件平台,默认安装的驱动在此。
                #说明：工厂出货的zxc/zxc+/aio版本，无法通过PRODUCT_NAME识别（不同项目或批次的机器，其他PRODUCT_NAME不同），改用VERSION_NAME识别。
                #VERSION_NAME，AIO:KaiTianA6100, ZXC与ZXC+:KaiTianM6100
		*)
			case ${VERSION_NAME} in
				#工厂出货的AIO机型
				KaiTianA6100)
					#echo "install_20_zxc_AIO_drv"
					install_20_zxc_AIO_drv
				;;

				#工厂出货的zxc\zxc+机型
				KaiTianM6100 | KaiTianS6100)
					#echo "install_20_ZXC_drv"
					install_20_ZXC_drv
				;;

				*)
				;;
			esac
		;;
	esac
else
	echo "New machine?"
fi
}

#ZXC平台+3.0系统。ZXC平台支持台式机、AIO一体机、CF03笔记本、CF03-T笔记本和miniPC。
ZXC_30_install_drv()
{
#echo "ZXC_30_install_drv"
purge_30_s3g_drivers

#ZXC:miniPC
if [ "$MANUFACTURER" = "INESA" ]; then
	#echo "install_30_zxc_INESA_drv"
	install_30_zxc_INESA_drv

#ZXC:台式机、AIO一体机、CF03笔记本、CF03-T笔记本; 含ZXC+和ZXA处理
elif [ "$MANUFACTURER" = "LENOVO" ]; then

	case ${PRODUCT_NAME} in
		#针对ZXC CF03笔记本
		CF03)
			#echo "install_30_zxc_cf03_drv"
			install_30_zxc_cf03_drv
		;;

		#针对笔记本ZXC CF03-T笔记本
		CF03-T)
			#echo "install_30_zxc_cf03t_drv"
			install_30_zxc_cf03t_drv
		;;
		#Add other platform here...

		#zxa\zxc\zxc+\aio\台式开发机支持。
		#注意该项包含AIO开发机支持，但无法区分zxa\zxc\zxc+台式机和aio，使用的是zxc台式机的驱动，只能手动测试。
		FFFFFFFFFF)
			#echo "install_30_ZXC_drv"
			install_30_ZXC_drv
		;;

		#其他硬件平台,默认安装的驱动在此。
                #说明：工厂出货的zxc/zxc+/aio版本，无法通过PRODUCT_NAME识别（不同项目或批次的机器，其他PRODUCT_NAME不同），改用VERSION_NAME识别。
                #VERSION_NAME，AIO:KaiTianA6100, ZXC与ZXC+:KaiTianM6100
		*)
			case ${VERSION_NAME} in
				#工厂出货的AIO机型
				KaiTianA6100)
					#echo "install_30_zxc_AIO_drv"
					install_30_zxc_AIO_drv
				;;

				#工厂出货的zxc\zxc+机型
				KaiTianM6100 | KaiTianS6100)
					#echo "install_30_ZXC_drv"
					install_30_ZXC_drv
				;;

				*)
				;;
			esac
		;;
	esac
else
	echo "New machine?"
fi
}

########## ZXD机型支持 ##########

#ZXD平台+1.5系统：ZXD平台目前仅支持台式机.
ZXD_15_install_drv()
{
if [ "$MANUFACTURER" = "LENOVO" ]; then

	#echo "ZXD_15_install_drv"
	case ${PRODUCT_NAME} in
		#ZXD台式开发机支持
		FFFFFFFFFF)
			#echo "install_15_ZXD_drv"
			install_15_ZXD_drv
		;;

		#其他硬件平台,默认安装的驱动在此。
                #说明：工厂出货的zxd版本，无法通过PRODUCT_NAME识别（不同项目或批次的机器，其他PRODUCT_NAME不同），改用VERSION_NAME识别。
                #VERSION_NAME，AIO:KaiTianA6200, ZXD:KaiTianM6200或KaiTianS6200
		*)
			case ${VERSION_NAME} in
				#工厂出货的ZXD AIO机型
				*A6200)
					#echo "install_15_zxd_AIO_drv"
					install_15_zxd_AIO_drv
				;;

				#工厂出货的ZXD机型
				*M6200 | *S6200)
					#echo "install_15_ZXD_drv"
					install_15_ZXD_drv
				;;

				*)
				;;
			esac
		;;
	esac
else
	echo "New machine?"
fi
}

#ZXD平台+2.0系统：ZXD平台目前仅支持台式机.
ZXD_20_install_drv()
{
if [ "$MANUFACTURER" = "LENOVO" ]; then
	#echo "ZXD_20_install_drv"
	case ${PRODUCT_NAME} in
		#ZXD台式开发机支持
		FFFFFFFFFF)
			#echo "install_20_ZXD_drv"
			install_20_ZXD_drv
		;;

		#其他硬件平台,默认安装的驱动在此。
                #说明：工厂出货的zxd版本，无法通过PRODUCT_NAME识别（不同项目或批次的机器，其他PRODUCT_NAME不同），改用VERSION_NAME识别。
                #VERSION_NAME，AIO:KaiTianA6200, ZXD:KaiTianM6200或KaiTianS6200
		*)
			case ${VERSION_NAME} in
				#工厂出货的ZXD AIO机型
				*A6200)
					#echo "install_20_zxd_AIO_drv"
					install_20_zxd_AIO_drv
				;;

				#工厂出货的ZXD机型
				*M6200 | *S6200)
					#echo "install_20_ZXD_drv"
					install_20_ZXD_drv
				;;

				*)
				;;
			esac
		;;
	esac
else
	echo "New machine?"
fi
}

#ZXD平台+3.0系统：ZXD平台目前仅支持台式机.
ZXD_30_install_drv()
{
purge_30_s3g_drivers
if [ "$MANUFACTURER" = "LENOVO" ]; then
	#echo "ZXD_30_install_drv"
	case ${PRODUCT_NAME} in
		#ZXD台式开发机支持
		FFFFFFFFFF)
			#echo "install_30_ZXD_drv"
			install_30_ZXD_drv
		;;

		#其他硬件平台,默认安装的驱动在此。
                #说明：工厂出货的zxd版本，无法通过PRODUCT_NAME识别（不同项目或批次的机器，其他PRODUCT_NAME不同），改用VERSION_NAME识别。
                #VERSION_NAME，AIO:KaiTianA6200, ZXD:KaiTianM6200或KaiTianS6200
		*)
			case ${VERSION_NAME} in
				#工厂出货的ZXD AIO机型
				*A6200)
					#echo "install_30_zxd_AIO_drv"
					install_30_zxd_AIO_drv
				;;

				#工厂出货的ZXD机型
				*M6200 | *S6200)
					#echo "install_30_ZXD_drv"
					install_30_ZXD_drv
				;;

				*)
				#由于联想机器不断更新，经常不按早先约定好的机型信息。因此，在判定cpu厂家、cpu型号后，
				#无法判定机器类型情况下，先按兆芯D机型集成显卡处理，即安装兆芯D集成显卡驱动。
				#见bug:0350872: HGJ1017oem/livecd版本集显下ZXD新批次，系统安装过程中没有安装集显驱动，
				#安装完成后重启才开始安装集显驱动，ZXD老批次（SIT机型）无此问题
					#echo "Default install zxd 3.0 drivers."
					install_30_ZXD_drv
				;;
			esac
		;;
	esac
else
	echo "New machine?"
fi
}


########## ZXE机型支持 ##########

#ZXE平台+1.5系统：ZXE平台目前仅支持台式机.
ZXE_15_install_drv()
{
	echo "Not supported!"
}

#ZXE平台+2.0系统：ZXE平台目前仅支持台式机.
ZXE_20_install_drv()
{
	echo "Not supported!"
}

#ZXE平台+3.0系统：ZXE平台目前仅支持台式机.
ZXE_30_install_drv()
{
	#兆芯确认：ZXE平台及以后平台，所有集显驱动合并为一个，驱动名称统一为：zhaoxin-linux-graphics-driver.
	#此种情况下，是否所有批次设备，包括不同厂家设备，均可以统一使用该zhaoxin-linux-graphics-driver驱动？
	#确认：不同方德系统（1.5,2.0,3.0），是否可以使用该同一驱动？
	install_30_ZXE_drv
}


########## 删除无须保留的驱动安装包 ##########

#注意:因脚本是在系统安装脚本中执行，需确保系统安装完成后，方可删除这些软件包
#风险:1,名字写错，有可能无法删除目标;2.目标路径错误,因脚本执行在虚拟系统环境
rm_drivers_debs()
{
	#删除wifi驱动包等
	chroot /target /bin/bash -c "rm -f ${DRV_PATH}/tl-wn725n_*.deb"
	chroot /target /bin/bash -c "rm -f ${DRV_PATH}/backports-4.4.2-1_*.deb"
	chroot /target /bin/bash -c "rm -f ${DRV_PATH}/backports-20150903_*.deb"
	#删除键盘映射
	chroot /target /bin/bash -c "rm -f ${DRV_PATH}/hotkey-init_*.deb"
	#删除cf03-t patch deb
	#chroot /target /bin/bash -c "rm -f ${DRV_PATH}/cf03t-patch_*.deb" #该包出过测试版，正式版移除
	#注意保留显卡驱动程序，显卡切换适用.
}

#将自己软件包从系统构建中删除
#风险：有可能无法删除，但不影响系统其他功能
remove_package_itself()
{
	#本软件包名platform-hw-ident
	chroot /target /bin/bash -c "dpkg -P platform-hw-ident"
}

################################################ main ###########################################################

#第一步:2017-09 通过/proc/cpuinfo中的vendor_id来区分兆芯CPU和通用x86 CPU。兆芯CPU vendor_id :Shanghai 或 CentaurHauls
#第二步：通过/proc/cpuinfo中的model name来区分ZX平台类型。ZXA：VIA Nano X2; ZXC:C-QuadCore; ZXC+:ZHAOXIN KaiXian ZX-C+; ZXD:ZHAOXIN KaiXian ZX-D.
#第三步:确定特定兆芯平台类型的机器类型。ZXA：只有台式机；ZXC：包括台式机、AIO一体机、CF03笔记本、CF03-T笔记本和miniPC；ZXD：目前只有台式机.
#第四步:确定系统版本。目前系统版本为：1.5,2.0和3.0.以内核版本区分.
#第五步:根据机型和系统版本，调用对应的sh，安装对应的驱动.

#获取CPU vendor_id和model name.
CPU_VENDOR_ID=`grep -i "vendor_id" /proc/cpuinfo | sort | uniq | awk -F ":" '{print $2}' | sed 's/^[ \t]*//g' | sed 's/[ \t]*$//g'`
CPU_MODEL_NAME=`grep -i "model name" /proc/cpuinfo | sort | uniq | awk -F ":" '{print $2}' | sed 's/^[ \t]*//g' | sed 's/[ \t]*$//g'`

#内核版本获取
KERNEL_VERSION=`uname -r`

#201901兆芯计划：ZXE平台及以后平台采用判定cpuinfo中model（Model/Extend Model）方式来确定
#此方法在早期的ZXD/C/A平台存在不适用情况，所以保留了早期对兆芯D\C\A平台的判定方法
#兆芯E平台cpuinfo的Extend Model为3（bit[5:4]）, Model为B（bit[3:0]）
#cpuinfo model(十进制)
CPUMODEL_DEC=`cat /proc/cpuinfo | grep -v "model name" | grep "model" | awk -F : '{print $2}' | sed 's/ //g' | sort -u `
#cpuinfo model(十六进制)
CPUMODEL_HEX=`echo 'obase=16; '$CPUMODEL_DEC'' | bc`
#取得Model，即低4位 bit[3:0]
CPUMODEL=`printf "%x" $((0x$CPUMODEL_HEX&0x0F))`
#取得Extend Model,即 bit[5:4]
CPUMODEL_EX_TEMP=`printf "%x" $((0x$CPUMODEL_HEX&0x30))`
CPUMODEL_EX=`printf "%x" $((0x$CPUMODEL_EX_TEMP >> 4))`

if [ "$CPU_VENDOR_ID" = "CentaurHauls" -o "$CPU_VENDOR_ID" = "Shanghai" ]; then #ZX平台

   if [ "${CPUMODEL_EX}" = "3" -a "${CPUMODEL}" = "b" ] ;then #确定ZXE平台
	#For ZXE
		case $KERNEL_VERSION in
			4.9*)
			#OS 3.1
			ZXE_30_install_drv
			;;
			*)
			echo "other kernel version"
			;;
		esac
	#end ZXE

   else #除ZXE之外的其他ZX平台

	#确定ZX平台类型
	case $CPU_MODEL_NAME in
		VIA?Nano?X2*)
		#ZXA平台。只有台式机，无其他机型
		#echo "ZXA平台"
		case $KERNEL_VERSION in
			3.19*)
			#OS 1.5
			#echo "OS VERSION 1.5"
			ZXC_15_install_drv
			;;
			4.3*)
			#OS 2.0
			#echo "OS VERSION 2.0"
			ZXC_20_install_drv
			;;
			4.9*)
			#OS 3.0
			#echo "OS VERSION 3.0"
			ZXC_30_install_drv
			;;
		esac
		;;
		C-QuadCore*)
		#ZXC平台。目前机型分为：台式机，一体机，CF03笔记本、CF03-T笔记本和miniPC。
		#echo "ZXC平台"
		case $KERNEL_VERSION in
			3.19*)
			#OS 1.5
			#echo "OS VERSION 1.5"
			ZXC_15_install_drv
			;;
			4.3*)
			#OS 2.0
			#echo "OS VERSION 2.0"
			ZXC_20_install_drv
			;;
			4.9*)
			#OS 3.0
			#echo "OS VERSION 3.0"
			ZXC_30_install_drv
			;;
		esac
		;;
		ZHAOXIN*ZX-C*)
		#ZXC+平台。目前只有台式机，无其他机型。
		#echo "ZXC+平台"
		case $KERNEL_VERSION in
			3.19*)
			#OS 1.5
			#echo "OS VERSION 1.5"
			ZXC_15_install_drv
			;;
			4.3*)
			#OS 2.0
			#echo "OS VERSION 2.0"
			ZXC_20_install_drv
			;;
			4.9*)
			#OS 3.0
			#echo "OS VERSION 3.0"
			ZXC_30_install_drv
			;;
		esac
		;;
		ZHAOXIN*ZX-D*)
		#ZXD平台。目前只有台式机，无其他机型。
		#echo "ZXD平台"
		case $KERNEL_VERSION in
			3.19*)
			#OS 1.5
			#echo "OS VERSION 1.5"
			ZXD_15_install_drv
			;;
			4.3*)
			#OS 2.0
			#echo "OS VERSION 2.0"
			ZXD_20_install_drv
			;;
			4.9*)
			#OS 3.0
			#echo "OS VERSION 3.0"
			ZXD_30_install_drv
			;;
		esac
		;;

		ZHAOXIN*KaiXian*KX-*)
		#ZXD平台,2018-1新机型台式机器 CPU信息:ZHAOXIN KaiXian KX-5640@2.0GHz
		#echo "ZXD平台"
		case $KERNEL_VERSION in
			3.19*)
			#OS 1.5
			#echo "OS VERSION 1.5"
			ZXD_15_install_drv
			;;
			4.3*)
			#OS 2.0
			#echo "OS VERSION 2.0"
			ZXD_20_install_drv
			;;
			4.9*)
			#OS 3.0
			#echo "OS VERSION 3.0"
			ZXD_30_install_drv
			;;
		esac
		;;

	esac	
   fi #end ZXE detect [ "${CPUMODEL_EX}" = "3" -a "${CPUMODEL}" = "b" ]
else
	#通用X86平台
	echo "Generic X86 CPU,do nothing."
fi

#删除无须保留的驱动安装包
rm_drivers_debs

#将自己软件包从系统构建中删除,暂时屏蔽，等稳定再考虑
#remove_package_itself
echo "=== All done ==="
#因集成的ISO没有安装grub,而去掉exit 0. 连带remove_package_itself也屏蔽
#exit 0
